Unit ZP16R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTZP10_p;

procedure ZP16R(var A :Array of Real; var NREAL :Integer;
                var ROOT :Array of Real; var IERR :Integer);

implementation

procedure ZP16R(var A :Array of Real; var NREAL :Integer;
                var ROOT :Array of Real; var IERR :Integer);
var
X,Y,Z,P,Q,R,R1,R2 :Real;
const
SYS007 :Real = 1.0471975511965977461542144610932;
label
_11,_12,_13,_14,_15,_16,_9005;
begin
IERR := 0;
R1 := 3.0*A[0];
if ( A[0] <> 0.0 ) 
 then goto _11;
IERR := 65;
UTZP10(IERR,16);
goto _9005;
_11:
R2 := A[1]/R1;
X := A[2]/R1-IntPower(R2,2);
Y := 3.0*A[3]/R1+2.0*IntPower(R2,3)-3.0*R2*(A[2]/R1);
Z := -2.0*Sqrt(Abs(X));
if ( X <> 0.0 ) or ( Y <> 0.0 ) 
 then goto _12;
NREAL := 3;
ROOT[0] := -R2;
ROOT[1] := ROOT[0];
ROOT[2] := ROOT[0];
goto _9005;
_12:
if ( Abs(Y)-X*Z ) < 0
 then goto _13
 else if ( Abs(Y)-X*Z ) > 0
       then goto _14
       else goto _15;
_13:
NREAL := 3;
Y := (Y/X)/Z;
Y := (2.0/3.0)*ArcTan2(Sqrt(1.0-Y),Sqrt(1.0+Y));
P := Z*Cos(Y)-R2;
X := -Z*Cos(Y-SYS007)-R2;
Y := -Z*Cos(Y+SYS007)-R2;
ROOT[0] := EMin1(EMin1(P,X),Y);
ROOT[2] := EMax1(EMax1(P,X),Y);
ROOT[1] := -A[1]/A[0]-ROOT[0]-ROOT[2];
goto _9005;
_14:
Z := X*Z;
R1 := EMax1(Abs(Y),Abs(Z));
Z := R1*Sqrt(IntPower(Y/R1,2)-(Z/R1)*(Abs(Z)/R1));
if ( Z = 0.0 ) 
 then goto _16;
Z := 0.5*(Z+(Y/Z)*Y+(4.0*X/Z)*X*X);
goto _16;
_15:
Z := 0.0;
_16:
NREAL := 1;
P := Y+Z;
X := Sign(Power((Sqrt(0.5)*Sqrt(Abs(P))),2.0/3.0),P);
P := Y-Z;
Y := Sign(Power((Sqrt(0.5)*Sqrt(Abs(P))),2.0/3.0),P);
Z := X+Y;
ROOT[0] := -Z-R2;
ROOT[1] := 0.5*Z-R2;
ROOT[2] := Sqrt(0.75)*Abs(X-Y);
_9005:
end;

end.
